"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var uuid_1 = require("uuid");
var localForage = require("localforage");
var rxjs_1 = require("rxjs");
var RTStorage = /** @class */ (function () {
    function RTStorage(_a) {
        var _this = this;
        var name = _a.name;
        this._name = name;
        this._id = uuid_1.v4();
        localForage.config({ name: this._name });
        this._storage = localForage.createInstance({
            name: this._name,
        });
        this._localStorage = localStorage;
        this._storageChangedEventKey = this._name + "_storage_changed";
        this._observable = new rxjs_1.Subject();
        this._tabSyncHandler = function (event) { return __awaiter(_this, void 0, void 0, function () {
            var _a, setter, key, value, e_1;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        if (!(event.key !== null &&
                            typeof event.key !== 'undefined' &&
                            event.key === this._storageChangedEventKey)) return [3 /*break*/, 4];
                        _b.label = 1;
                    case 1:
                        _b.trys.push([1, 3, , 4]);
                        _a = JSON.parse(event.newValue), setter = _a.setter, key = _a.key;
                        if (!setter || setter === this.id) {
                            return [2 /*return*/];
                        }
                        return [4 /*yield*/, this.getItem(key)];
                    case 2:
                        value = _b.sent();
                        this._observable.next({ key: key, value: value });
                        return [3 /*break*/, 4];
                    case 3:
                        e_1 = _b.sent();
                        return [3 /*break*/, 4];
                    case 4: return [2 /*return*/];
                }
            });
        }); };
        window.addEventListener('storage', this._tabSyncHandler);
    }
    RTStorage.prototype.setItem = function (key, value) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.waitForReady()];
                    case 1:
                        _a.sent();
                        return [4 /*yield*/, this._storage.setItem(key, { value: value, setter: this.id })];
                    case 2:
                        _a.sent();
                        this._observable.next({ key: key, value: value });
                        this._updateStorageChangeKey(key);
                        return [2 /*return*/];
                }
            });
        });
    };
    RTStorage.prototype.getItem = function (key) {
        return __awaiter(this, void 0, void 0, function () {
            var originalData, value;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.waitForReady()];
                    case 1:
                        _a.sent();
                        return [4 /*yield*/, this._storage.getItem(key)];
                    case 2:
                        originalData = _a.sent();
                        try {
                            value = originalData.value;
                            return [2 /*return*/, value];
                        }
                        catch (error) {
                            return [2 /*return*/, undefined];
                        }
                        return [2 /*return*/];
                }
            });
        });
    };
    RTStorage.prototype.removeItem = function (key) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.waitForReady()];
                    case 1:
                        _a.sent();
                        return [4 /*yield*/, this._storage.removeItem(key)];
                    case 2:
                        _a.sent();
                        this._observable.next({ key: key, value: undefined });
                        this._updateStorageChangeKey(key);
                        return [2 /*return*/];
                }
            });
        });
    };
    RTStorage.prototype.keys = function () {
        return __awaiter(this, void 0, void 0, function () {
            var keys;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.waitForReady()];
                    case 1:
                        _a.sent();
                        return [4 /*yield*/, this._storage.keys()];
                    case 2:
                        keys = _a.sent();
                        return [2 /*return*/, keys];
                }
            });
        });
    };
    RTStorage.prototype._updateStorageChangeKey = function (key) {
        this._localStorage.setItem(this._storageChangedEventKey, JSON.stringify({
            timestamp: Date.now(),
            key: key,
            setter: this.id,
        }));
    };
    Object.defineProperty(RTStorage.prototype, "id", {
        get: function () {
            return this._id;
        },
        enumerable: true,
        configurable: true
    });
    RTStorage.prototype.waitForReady = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (this._ready) {
                            return [2 /*return*/];
                        }
                        if (!(typeof this._storage.ready === 'function')) return [3 /*break*/, 2];
                        return [4 /*yield*/, this._storage.ready()];
                    case 1:
                        _a.sent();
                        _a.label = 2;
                    case 2:
                        this._ready = true;
                        return [2 /*return*/];
                }
            });
        });
    };
    Object.defineProperty(RTStorage.prototype, "$", {
        get: function () {
            return this._observable;
        },
        enumerable: true,
        configurable: true
    });
    RTStorage.prototype.subscribe = function (keyOrFunc, func) {
        if (typeof keyOrFunc === 'function') {
            return this._observable.subscribe(keyOrFunc);
        }
        return this._observable.subscribe(function (e) {
            if (e.key === keyOrFunc) {
                func(e.value);
            }
        });
    };
    RTStorage.prototype.destory = function () {
        if (this._tabSyncHandler) {
            window.removeEventListener('storage', this._tabSyncHandler);
        }
    };
    return RTStorage;
}());
exports.default = RTStorage;
//# sourceMappingURL=index.js.map